/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.modules.screens;

import java.util.ArrayList;

import net.sf.json.JSONArray;

import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.eip.document.FolderInfo;
import com.aimluck.eip.document.util.DocumentUtils;
import com.aimluck.eip.common.ALEipConstants;
import com.aimluck.eip.document.DocumentFileFormData;
import com.aimluck.eip.document.DocumentFileMultiDelete;
import com.aimluck.eip.util.ALEipUtils;
import com.aimluck.eip.document.common.DocumentConstants;

/**
 * 文書管理のファイルをJSONデータとして出力するクラスです。 <br />
 * 
 */
public class DocumentFileFormJSONScreen extends ALJSONScreen {
  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(DocumentFileFormJSONScreen.class.getName());

  @Override
  protected String getJSONString(RunData rundata, Context context)
      throws Exception {
    String result = new JSONArray().toString();
    String mode = this.getMode();
    try {

      synchronized (Global.lock) {
      if (ALEipConstants.MODE_INSERT.equals(mode)) {
        //
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doInsert(this, rundata, context)) {
          FolderInfo info = formData.getSelectedFolderInfo();
          ALEipUtils.setTemp(rundata, context, DocumentUtils.KEY_FOLDER_ID, ""
              + info.getFolderId());

        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }

      } 
      else if (ALEipConstants.MODE_CHECKIN.equals(mode)
            || DocumentConstants.MODE_REQUEST_CHECKIN.equals(mode)
            || DocumentConstants.MODE_REQAGAIN_CHECKIN.equals(mode)) {
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        //System.out.println("checkin!!");
        if (formData.doCheckin(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } 
      else if (ALEipConstants.MODE_UPDATE.equals(mode)) {

        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doUpdate(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (ALEipConstants.MODE_CHECKOUT.equals(mode)
          || DocumentConstants.MODE_REQUEST_CHECKOUT.equals(mode)) {
        
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doCheckOut(this,rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (ALEipConstants.MODE_DELETE.equals(mode)) {

        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doDelete(this,rundata, context)) {
          FolderInfo info = formData.getSelectedFolderInfo();
          ALEipUtils.setTemp(rundata, context, DocumentUtils.KEY_FOLDER_ID, ""
              + info.getFolderId());

        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if ("multi_delete".equals(mode)) {

        DocumentFileMultiDelete delete = new DocumentFileMultiDelete();
        if (delete.doMultiAction(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if("checkoutCancel".equals(mode)) {
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doCheckoutCancel(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      }else if(DocumentConstants.MODE_REQUEST_INSERT.equals(mode)
          || DocumentConstants.MODE_REQAGAIN_INSERT.equals(mode)){
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doRequestInsert(this, rundata, context)) {
          FolderInfo info = formData.getSelectedFolderInfo();
          ALEipUtils.setTemp(rundata, context, DocumentUtils.KEY_FOLDER_ID, ""
              + info.getFolderId());

        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (DocumentConstants.MODE_REQUEST_CANCEL.equals(mode)) {

        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doRequestCancel(this,rundata, context)) {
          FolderInfo info = formData.getSelectedFolderInfo();
          ALEipUtils.setTemp(rundata, context, DocumentUtils.KEY_FOLDER_ID, ""
              + info.getFolderId());

        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (DocumentConstants.MODE_REQUEST_DELETE.equals(mode)){
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doRequestDelete(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      } else if (DocumentConstants.MODE_REQUEST_CHECKOUT_CANCEL.equals(mode)){
        DocumentFileFormData formData = new DocumentFileFormData();
        formData.initField();
        if (formData.doRequestCheckoutCancel(this, rundata, context)) {
        } else {
          ArrayList list = (ArrayList) context
              .get(ALEipConstants.ERROR_MESSAGE_LIST);
          JSONArray json = JSONArray.fromObject(list);
          result = json.toString();
        }
      }
      }
    } catch (Exception e) {
      logger.error("[DocumentFileFormJSONScreen]", e);
    }

    return result;
  }
}

class Global {
  static Object lock = new Object();
}